----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:16:45 05/11/2015 
-- Design Name: 
-- Module Name:    top_level_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top_level_counter is
port (
	clk, reset 	: in STD_LOGIC;
	freeze, up_down	: in STD_LOGIC;
	count		: out unsigned(3 downto 0)
);
end top_level_counter;

architecture Behavioral of top_level_counter is

signal clk_div : STD_LOGIC;

begin

	-- Instantiate the frequency divider
	freq_div_unit: 
	entity work.freq_div(Behavioral) 
	generic map(CLK_INPUT  => 50000000,		--Clock input frequency:  50MHz
					CLK_OUTPUT => 2)				--Clock output frequency: 2Hz
	port map(clk_in  => clk,
				clk_out => clk_div);
	

	-- Instantiate the 4-bit binary counter
	counter_4b_unit: 
	entity work.counter_4b(Behavioral) 
	port map(clk     => clk_div,
				reset   => reset,
				freeze  => freeze,
				up_down => up_down,
				count   => count);

end Behavioral;

